//
//  TDLDocument.m
//  ModernToDoList
//
//  Created by narita on 2016/09/29.
//  Copyright © 2016年 narita. All rights reserved.
//

#import "TDLDocument.h"
#import "TDLWindowController.h"

@interface TDLDocument ()

@end

@implementation TDLDocument

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

- (instancetype)init 
{
    self = [super init];
    
    if (self) 
    {
        // Add your subclass-specific initialization here.
    }
    
    return self;
}

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark state restore methods

- (void)restoreDocumentWindowWithIdentifier:(NSString *)identifier
                                      state:(NSCoder *)state
                          completionHandler:(void (^)(NSWindow *, NSError *))completionHandler
{    
    NSString* theDocumentWindowIdentifer = [NSString stringWithFormat:@"%@:", 
                                            NSStringFromClass(self.windowControllerClass)];
    
    if ([identifier hasPrefix:theDocumentWindowIdentifer])
    {
        NSString* theIndexString = [identifier substringFromIndex:[theDocumentWindowIdentifer length]];
        NSInteger theIndex       = [theIndexString integerValue];
        
        NSWindow*           theWindow           = nil;
        NSWindowController* theWindowController = nil;
        
        if( self.windowControllers.count > theIndex )
        {
            theWindowController = [self.windowControllers objectAtIndex:theIndex];
            
            theWindow = theWindowController.window;
        }
        else
        {            
            theWindowController = [self makeNewWindowController];
            
            theWindow = theWindowController.window;
        }
        
        completionHandler(theWindow, nil);
    }
    else
    {
        [super restoreDocumentWindowWithIdentifier:identifier
                                             state:state
                                 completionHandler:completionHandler];
    }
}

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

- (IBAction)makeNewWindow:(id)sender
{
    [self makeNewWindowController];
}

#pragma mark -
#pragma mark window handling methods

- (Class) windowControllerClass
{
    return [TDLWindowController class];
}

- (NSWindowController*) makeNewWindowController
{
    NSString* theWindowControllerName = NSStringFromClass([self windowControllerClass]);
    
    NSWindowController*	theController = [[NSStoryboard storyboardWithName:theWindowControllerName
                                                                   bundle:nil]
                                         instantiateInitialController];
    
    theController.shouldCascadeWindows = YES;
    [self addWindowController:theController];
    
    [theController showWindow:self];
    
    return theController;
}

- (void) makeWindowControllers
{
    [self makeNewWindow:self];
}

- (void)addWindowController: (NSWindowController *)windowController
{
    [super addWindowController:windowController];
    
    [self.windowControllers makeObjectsPerformSelector:@selector(synchronizeWindowTitleWithDocumentName)];
    [self.windowControllers makeObjectsPerformSelector:@selector(synchronizeUserInterfaceIdentifier)];
}

- (void)removeWindowController: (NSWindowController *)windowController
{
    [super removeWindowController:windowController];
    
    [self.windowControllers makeObjectsPerformSelector:@selector(synchronizeWindowTitleWithDocumentName)];
    [self.windowControllers makeObjectsPerformSelector:@selector(synchronizeUserInterfaceIdentifier)];
}

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

+ (BOOL)autosavesInPlace 
{
    return YES;
}

#pragma mark -
#pragma mark Utility methods



@end
