//
//  TDLToDoItemCellView.m
//  ModernToDoList
//
//  Created by narita on 2016/09/30.
//  Copyright © 2016年 narita. All rights reserved.
//

#import "TDLToDoItemCellView.h"
#import "ToDoItem+CoreDataClass.h"

@implementation TDLToDoItemCellView

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark state restore methods

#pragma mark -
#pragma mark awakeFromNib-like methods

- (void) awakeFromNib
{
    self.textField.delegate = self;
    [self.textField setTarget:self];
    [self.textField setAction:@selector(changedTextField:)];
    
    [self.checkBox setTarget:self];
    [self.checkBox setAction:@selector(changedCheckBox:)];
}

#pragma mark -
#pragma mark action methods

- (IBAction) changedTextField:(id)sender
{
    ToDoItem* theItem = self.objectValue;
    
    theItem.memo = self.textField.stringValue;    
}

- (IBAction) changedCheckBox:(id)sender
{
    ToDoItem* theItem = self.objectValue;

    theItem.done = self.checkBox.objectValue;
}

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

- (void) setObjectValue:(nullable id)inObjectValue
{
    [super setObjectValue:inObjectValue];
    
    {
        ToDoItem* theItem = inObjectValue;
        
        self.textField.objectValue = theItem.memo;
        self.checkBox.objectValue  = theItem.done;
        self.date.objectValue      = theItem.createdDate.description;
        self.debugLabel.objectValue = @(theItem.sortOrder);
    }
}

#pragma mark -
#pragma mark Utility methods


@end
