//
//  TDLWindowController.m
//  ModernToDoList
//
//  Created by narita on 2016/09/30.
//  Copyright © 2016年 narita. All rights reserved.
//

#import "TDLWindowController.h"

@interface TDLWindowController ()

@end

@implementation TDLWindowController

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    
    if( self )
    {
        
    }
    
    return self;
}

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark state restore methods

#pragma mark -
#pragma mark awakeFromNib-like methods

- (void)windowWillLoad
{
    [super windowWillLoad];
}

- (void)windowDidLoad 
{
    [super windowDidLoad];
    
    self.window.titleVisibility = NSWindowTitleHidden;
    
    if( self.window.toolbar.visible == NO )
    {
        [self.window toggleToolbarShown:nil];        
    }
    
    if( self.window.tabbedWindows != nil )
    {
        // これを呼び出すと、shouldCascadeWindowsの設定が無効化されている。原因は不明。
        [self.window toggleTabBar:nil];            
    }
}

#pragma mark -
#pragma mark action & canAction methods


#pragma mark -
#pragma mark delegate/datasource methods

- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)window
{
    NSPersistentDocument* theDoc = self.document; 
    
    return theDoc.managedObjectContext.undoManager;
}

#pragma mark -
#pragma mark accessor methods (in pairs)

@dynamic shouldCascadeWindows;

#pragma mark -
#pragma mark Utility methods

- (NSString *) windowTitleForDocumentDisplayName: (NSString *)displayName
{
    if( [self document] != nil )
    {
        NSDocument* theDocument = self.document;
        
        if( [theDocument.windowControllers count] > 1)
        {
            NSUInteger	theIndex;
            NSString*	theResult;
            
            //	NSArrayのindexが０から始まるため+1する
            theIndex = [theDocument.windowControllers indexOfObject:self] + 1;
            
            theResult = [NSString stringWithFormat:@"%@:(%lu)", theDocument.displayName, theIndex];
            
            return theResult;
        }
        else
        {
            return [super windowTitleForDocumentDisplayName:displayName];
        }
    }
    else
    {
        return [super windowTitleForDocumentDisplayName:displayName];
    }
    

}

- (void) synchronizeUserInterfaceIdentifier
{
    NSDocument* theDocument = self.document;
    
    
    if( theDocument != nil )
    {
        NSUInteger theIndex = [theDocument.windowControllers indexOfObject:self];
        
        self.window.identifier = [NSString stringWithFormat:@"%@:%lu", 
                                  NSStringFromClass(self.class),
                                  theIndex];
    }
}

@end
