//
//  ToDoItem_coding.m
//  ModernToDoList
//
//  Created by narita on 2016/10/02.
//  Copyright © 2016年 narita. All rights reserved.
//

#import "ToDoItem_coding.h"

@implementation ToDoItem (ToDoItem_coding)

+ (NSString*) pasteBoardRowsType
{
    return @"com.mindto01s.ToDoItem";
}

#pragma mark -
#pragma mark NSPasteboardWriting methods

// ペーストボードへ書き込む型
- (NSArray<NSString *> *)writableTypesForPasteboard:(NSPasteboard *)pasteboard
{
    return @[[ToDoItem pasteBoardRowsType]];
}

// ペーストボードに書き込むためのプロパティリストに変更可能な形式にする
- (id)pasteboardPropertyListForType:(NSString *)type
{
    id theResult = nil;
    
    if( [type isEqualToString:[ToDoItem pasteBoardRowsType]] )
    {
        NSDictionary* theDict =
        @{
          @"createdDate" : self.createdDate,
          @"memo"        : self.memo,
          @"done"        : self.done, 
          @"sortOrder"   : @(self.sortOrder), 
          @"objectURL"   : [self.objectID.URIRepresentation pasteboardPropertyListForType:(id)kUTTypeURL]
                            };
                
        theResult = theDict; 
    }
    
    return theResult;
}

#pragma mark -
#pragma mark NSPasteboardReading(?) methods// ペーストボードにあるデータからToDoItemのインスタンスを作成する
+ (ToDoItem*) toDoItemFromNSPasteboard:(NSPasteboard*)inPasteboard
                  managedObjectContext:(NSManagedObjectContext*)inManagedObjectContext
{    
    NSDictionary* thePasteObject = [inPasteboard propertyListForType:[ToDoItem pasteBoardRowsType]]; 
    ToDoItem*     theItem        = [[ToDoItem alloc] initWithContext:inManagedObjectContext];
    
    theItem.memo        = [thePasteObject objectForKey:@"memo"];
    theItem.done        = [thePasteObject objectForKey:@"done"];
    theItem.createdDate = [thePasteObject objectForKey:@"createdDate"];
    theItem.sortOrder   = [[thePasteObject objectForKey:@"sortOrder"] integerValue];
    
    return theItem;
}

@end
